#include <stdio.h>
#include <stdlib.h>
#include <mysql.h>
#include "stock.h"

MYSQL *connection, mysql;
char *error;

int init_api() {
    error = (char *)NULL;
    mysql_init(&mysql);
    connection = mysql_real_connect(&mysql, "localhost", "orausr",
                                    "orapw", "oradb", 0, 0, 0);
    if( connection == NULL ) {
        error = mysql_error(&mysql);
        return -1;
    }
    else {
        return 0;
    }
}

void close_api() {
    error = (char *)NULL;
    if( connection != NULL ) {
        mysql_close(connection);
        connection = NULL;
    }
}

char *get_error() {
    return error;
}

int assign_stock(Stock *stock) {
    char *query = "INSERT INTO Stock ( symbol, openPrice, \
                   currPrice, high52, low52 ) \
                   VALUES ('%s', %f, %f, %f, %f)";
    char *sql;
    int state;

    sql = (char *)malloc(255 * sizeof(char));
    error = (char *)NULL;
    sprintf(sql, query,
            stock->symbol, stock->open_price, stock->current_price, 
            stock->high52, stock->low52);
    state = mysql_query(connection, sql);
    free(sql);
    if( state != 0 ) {
        error = mysql_error(connection);
        return -1;
    }
    return 0;
}

Stock *get_stock(char *symbol) {
    char *query = "SELECT symbol, openPrice, currPrice, high52, low52, \
                  FROM Stock WHERE symbol = '%s'";
    char *sql;
    int state;

    error = (char *)NULL;
    sql = (char *)malloc((strlen(query) + strlen(symbol) + 1) * sizeof(char));
    sprintf(sql, query, symbol);
    state = mysql_query(connection, sql);
    free(sql);
    if( state != 0 ) {
        error = mysql_error(connection);
        return (Stock *)NULL;
    }
    else {
        MYSQL_RES *result;
        Stock *stock;
        MYSQL_ROW row;
        
        result = mysql_store_result(connection);
        if( result == (MYSQL_RES *)NULL ) {
            error = mysql_error(connection);
            return (Stock *)NULL;
        }
        stock = (Stock *)malloc(sizeof(Stock));
        row = mysql_fetch_row(result);
        if( !row ) {
            error = "Invalid symbol.";
            mysql_free_result(result);
            return (Stock *)NULL;
        }
        stock->symbol = symbol;
        stock->open_price = atof(row[1]);
        stock->current_price = atof(row[2]);
        stock->high52 = atof(row[3]);
        stock->low52 = atof(row[4]);
        mysql_free_result(result);
        return stock;
    }
}

int main(char **args) {
    char *symbol = "MSFT";
    Stock *stock;
    char *err;
    
    if( init_api() == -1 ) {
        printf("%s\n", get_error());
        return -1;
    }
    stock = get_stock(symbol);
    if( stock == NULL ) {
        err = get_error();
        if( err == NULL ) {
            printf("No such stock: %s\n", symbol);
        }
        else {
            printf("Error:\n\t%s\n", err);
        }
    }
    else {
        printf("Price for %s: $%.2f (opened at $%.2f)\n", symbol,
               stock->current_price, stock->open_price);
        
    }
    close_api();
    return 0;
}

int main2(char **args) {
    Stock *stock = (Stock *)malloc(sizeof(Stock));
    
    if( init_api() == -1 ) {
        printf("%s\n", get_error());
        return -1;
    }
    stock->symbol = "MSFT";
    stock->open_price = 10.00;
    stock->current_price = 5.00;
    stock->high52 = 12.00;
    stock->low52 = 1.00;
    if( assign_stock(stock) == -1 ) {
        printf("Error:\n\t%s\n", get_error());
    }
    else {
        printf("Done.\n");
    }
    close_api();
    return 0;
}
